﻿
// enable double clicking from the Macintosh Finder or the Windows Explorer
#target photoshop

// in case we double clicked the file
app.bringToFront();

// debug level: 0-2 (0:disable, 1:break on error, 2:break at beginning)
// $.level = 0;
// debugger; // launch debugger on next line

var gRL = new RenameLayer();
gRL.CreateDialog();
gRL.RunDialog();

// the main class
function RenameLayer() {

	this.CreateDialog = function() {

		// I will keep most of the important dialog items at the same level
		// and use auto layout
		// use overriding group so OK/Cancel buttons placed to right of panel

		var res =
			"dialog { \
				pAndB: Group { orientation: 'row', \
                        s: StaticText { text:'Name:' }, \
                        e: EditText { preferredSize: [1024, 20] }, \
					buttons: Group { orientation: 'column', alignment: 'top',  \
						okBtn: Button { text:'ok', properties:{name:'ok'} }, \
						cancelBtn: Button { text:'cancel', properties:{name:'cancel'} } \
					} \
				} \
			}";

		// the following, when placed after e: in w and h doesn't show up
		// this seems to be OK since px is put inside the dialog box
		//p: StaticText { text:'" + strTextPixels + "'}

		// create the main dialog window, this holds all our data
		this.dlgMain = new Window(res,"Layer Name");

		// create a shortcut for easier typing
		var d = this.dlgMain;
        
        d.pAndB.e.text = activeDocument.activeLayer.name;

	    // match our dialog background color to the host application
        d.graphics.backgroundColor = d.graphics.newBrush (d.graphics.BrushType.THEME_COLOR, "appDialogBackground");
		d.defaultElement = d.pAndB.buttons.okBtn;
		d.cancelElement = d.pAndB.buttons.cancelBtn;
	} // end of CreateDialog

	// initialize variables of dialog
	this.InitVariables = function() {

		// make sure got parameters before this
		if (activeDocument.activeLayer == undefined)
		{
                alert('No Layer Selected!');
                return false; // if no docs, always return
		}

		return true;
	}

	// routine for running the dialog and it's interactions
	this.RunDialog = function () {
		var d = this.dlgMain;

		// in case hit cancel button, don't close
		d.pAndB.buttons.cancelBtn.onClick = function() {
			var dToCancel = FindDialog( this );
			dToCancel.close( false );
		}

		// nothing for now
		d.onShow = function() {
		}
    
		// hit OK, do resize
		d.pAndB.buttons.okBtn.onClick = function () {

    		// make sure got parameters before this
            if (activeDocument.activeLayer == undefined)
            {
                    alert('No Layer Selected!');
                    return false; // if no docs, always return
            }
        
            //activeDocument.activeLayer.name = d.pAndB.e.text;
            var oldLayer = activeDocument.activeLayer;

            // If the layer name is the same, just ignore
            if (oldLayer.name != d.pAndB.e.text)
            {
                // First just try to rename the layer
                oldLayer.name = d.pAndB.e.text
                
                // If that didn't update, try duplicating
                if (oldLayer.name != d.pAndB.e.text)
                {
                    var dupe = oldLayer.duplicate();
                    dupe.name = d.pAndB.e.text;
                    activeDocument.activeLayer = dupe;
                    oldLayer.remove();
                }
                
            }
            
            d.close(true);
        }
    
		if (!this.InitVariables())
		{
			return true; // handled it
		}

		// give the hosting app the focus before showing the dialog
		app.bringToFront();
		this.dlgMain.center();

		return d.show();
	}
}